// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: provenance/reward/v1/reward.proto

package types

import (
	fmt "fmt"
	github_com_cosmos_cosmos_sdk_types "github.com/cosmos/cosmos-sdk/types"
	types "github.com/cosmos/cosmos-sdk/types"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	github_com_gogo_protobuf_types "github.com/gogo/protobuf/types"
	_ "google.golang.org/protobuf/types/known/timestamppb"
	io "io"
	math "math"
	math_bits "math/bits"
	time "time"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf
var _ = time.Kitchen

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// State is the state of the reward program
type RewardProgram_State int32

const (
	// undefined program state
	RewardProgram_STATE_UNSPECIFIED RewardProgram_State = 0
	// pending state of reward program
	RewardProgram_STATE_PENDING RewardProgram_State = 1
	// started state of reward program
	RewardProgram_STATE_STARTED RewardProgram_State = 2
	// finished state of reward program
	RewardProgram_STATE_FINISHED RewardProgram_State = 3
	// expired state of reward program
	RewardProgram_STATE_EXPIRED RewardProgram_State = 4
)

var RewardProgram_State_name = map[int32]string{
	0: "STATE_UNSPECIFIED",
	1: "STATE_PENDING",
	2: "STATE_STARTED",
	3: "STATE_FINISHED",
	4: "STATE_EXPIRED",
}

var RewardProgram_State_value = map[string]int32{
	"STATE_UNSPECIFIED": 0,
	"STATE_PENDING":     1,
	"STATE_STARTED":     2,
	"STATE_FINISHED":    3,
	"STATE_EXPIRED":     4,
}

func (x RewardProgram_State) String() string {
	return proto.EnumName(RewardProgram_State_name, int32(x))
}

func (RewardProgram_State) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{0, 0}
}

// ClaimStatus is the state a claim is in
type RewardAccountState_ClaimStatus int32

const (
	// undefined state
	RewardAccountState_CLAIM_STATUS_UNSPECIFIED RewardAccountState_ClaimStatus = 0
	// unclaimable status
	RewardAccountState_CLAIM_STATUS_UNCLAIMABLE RewardAccountState_ClaimStatus = 1
	// unclaimable claimable
	RewardAccountState_CLAIM_STATUS_CLAIMABLE RewardAccountState_ClaimStatus = 2
	// unclaimable claimed
	RewardAccountState_CLAIM_STATUS_CLAIMED RewardAccountState_ClaimStatus = 3
	// unclaimable expired
	RewardAccountState_CLAIM_STATUS_EXPIRED RewardAccountState_ClaimStatus = 4
)

var RewardAccountState_ClaimStatus_name = map[int32]string{
	0: "CLAIM_STATUS_UNSPECIFIED",
	1: "CLAIM_STATUS_UNCLAIMABLE",
	2: "CLAIM_STATUS_CLAIMABLE",
	3: "CLAIM_STATUS_CLAIMED",
	4: "CLAIM_STATUS_EXPIRED",
}

var RewardAccountState_ClaimStatus_value = map[string]int32{
	"CLAIM_STATUS_UNSPECIFIED": 0,
	"CLAIM_STATUS_UNCLAIMABLE": 1,
	"CLAIM_STATUS_CLAIMABLE":   2,
	"CLAIM_STATUS_CLAIMED":     3,
	"CLAIM_STATUS_EXPIRED":     4,
}

func (x RewardAccountState_ClaimStatus) String() string {
	return proto.EnumName(RewardAccountState_ClaimStatus_name, int32(x))
}

func (RewardAccountState_ClaimStatus) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{2, 0}
}

// RewardProgram
type RewardProgram struct {
	// An integer to uniquely identify the reward program.
	Id uint64 `protobuf:"varint,1,opt,name=id,proto3" json:"id,omitempty"`
	// Name to help identify the Reward Program.(MaxTitleLength=140)
	Title string `protobuf:"bytes,2,opt,name=title,proto3" json:"title,omitempty"`
	// Short summary describing the Reward Program.(MaxDescriptionLength=10000)
	Description string `protobuf:"bytes,3,opt,name=description,proto3" json:"description,omitempty"`
	// address that provides funds for the total reward pool.
	DistributeFromAddress string `protobuf:"bytes,4,opt,name=distribute_from_address,json=distributeFromAddress,proto3" json:"distribute_from_address,omitempty"`
	// The total amount of funding given to the RewardProgram.
	TotalRewardPool types.Coin `protobuf:"bytes,5,opt,name=total_reward_pool,json=totalRewardPool,proto3" json:"total_reward_pool"`
	// The remaining funds available to distribute after n claim periods have passed.
	RemainingPoolBalance types.Coin `protobuf:"bytes,6,opt,name=remaining_pool_balance,json=remainingPoolBalance,proto3" json:"remaining_pool_balance"`
	// The total amount of all funds claimed by participants for all past claim periods.
	ClaimedAmount types.Coin `protobuf:"bytes,7,opt,name=claimed_amount,json=claimedAmount,proto3" json:"claimed_amount"`
	// Maximum reward per claim period per address.
	MaxRewardByAddress types.Coin `protobuf:"bytes,8,opt,name=max_reward_by_address,json=maxRewardByAddress,proto3" json:"max_reward_by_address"`
	// Minimum amount of coins for a program to rollover.
	MinimumRolloverAmount types.Coin `protobuf:"bytes,9,opt,name=minimum_rollover_amount,json=minimumRolloverAmount,proto3" json:"minimum_rollover_amount"`
	// Number of seconds that a claim period lasts.
	ClaimPeriodSeconds uint64 `protobuf:"varint,10,opt,name=claim_period_seconds,json=claimPeriodSeconds,proto3" json:"claim_period_seconds,omitempty"`
	// Time that a RewardProgram should start and switch to STARTED state.
	ProgramStartTime time.Time `protobuf:"bytes,11,opt,name=program_start_time,json=programStartTime,proto3,stdtime" json:"program_start_time"`
	// Time that a RewardProgram is expected to end, based on data when it was setup.
	ExpectedProgramEndTime time.Time `protobuf:"bytes,12,opt,name=expected_program_end_time,json=expectedProgramEndTime,proto3,stdtime" json:"expected_program_end_time"`
	// Time that a RewardProgram MUST end.
	ProgramEndTimeMax time.Time `protobuf:"bytes,13,opt,name=program_end_time_max,json=programEndTimeMax,proto3,stdtime" json:"program_end_time_max"`
	// Used internally to calculate and track the current claim period's ending time.
	ClaimPeriodEndTime time.Time `protobuf:"bytes,14,opt,name=claim_period_end_time,json=claimPeriodEndTime,proto3,stdtime" json:"claim_period_end_time"`
	// Time the RewardProgram switched to FINISHED state. Initially set as empty.
	ActualProgramEndTime time.Time `protobuf:"bytes,15,opt,name=actual_program_end_time,json=actualProgramEndTime,proto3,stdtime" json:"actual_program_end_time"`
	// Number of claim periods this program will run for.
	ClaimPeriods uint64 `protobuf:"varint,16,opt,name=claim_periods,json=claimPeriods,proto3" json:"claim_periods,omitempty"`
	// Current claim period of the RewardProgram. Uses 1-based indexing.
	CurrentClaimPeriod uint64 `protobuf:"varint,17,opt,name=current_claim_period,json=currentClaimPeriod,proto3" json:"current_claim_period,omitempty"`
	// maximum number of claim periods a reward program can rollover.
	MaxRolloverClaimPeriods uint64 `protobuf:"varint,18,opt,name=max_rollover_claim_periods,json=maxRolloverClaimPeriods,proto3" json:"max_rollover_claim_periods,omitempty"`
	// Current state of the RewardProgram.
	State RewardProgram_State `protobuf:"varint,19,opt,name=state,proto3,enum=provenance.reward.v1.RewardProgram_State" json:"state,omitempty"`
	// Grace period after a RewardProgram FINISHED. It is the number of seconds until a RewardProgram enters the EXPIRED
	// state.
	ExpirationOffset uint64 `protobuf:"varint,20,opt,name=expiration_offset,json=expirationOffset,proto3" json:"expiration_offset,omitempty"`
	// Actions that count towards the reward.
	QualifyingActions []QualifyingAction `protobuf:"bytes,21,rep,name=qualifying_actions,json=qualifyingActions,proto3" json:"qualifying_actions"`
}

func (m *RewardProgram) Reset()         { *m = RewardProgram{} }
func (m *RewardProgram) String() string { return proto.CompactTextString(m) }
func (*RewardProgram) ProtoMessage()    {}
func (*RewardProgram) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{0}
}
func (m *RewardProgram) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *RewardProgram) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_RewardProgram.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *RewardProgram) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RewardProgram.Merge(m, src)
}
func (m *RewardProgram) XXX_Size() int {
	return m.Size()
}
func (m *RewardProgram) XXX_DiscardUnknown() {
	xxx_messageInfo_RewardProgram.DiscardUnknown(m)
}

var xxx_messageInfo_RewardProgram proto.InternalMessageInfo

func (m *RewardProgram) GetId() uint64 {
	if m != nil {
		return m.Id
	}
	return 0
}

func (m *RewardProgram) GetTitle() string {
	if m != nil {
		return m.Title
	}
	return ""
}

func (m *RewardProgram) GetDescription() string {
	if m != nil {
		return m.Description
	}
	return ""
}

func (m *RewardProgram) GetDistributeFromAddress() string {
	if m != nil {
		return m.DistributeFromAddress
	}
	return ""
}

func (m *RewardProgram) GetTotalRewardPool() types.Coin {
	if m != nil {
		return m.TotalRewardPool
	}
	return types.Coin{}
}

func (m *RewardProgram) GetRemainingPoolBalance() types.Coin {
	if m != nil {
		return m.RemainingPoolBalance
	}
	return types.Coin{}
}

func (m *RewardProgram) GetClaimedAmount() types.Coin {
	if m != nil {
		return m.ClaimedAmount
	}
	return types.Coin{}
}

func (m *RewardProgram) GetMaxRewardByAddress() types.Coin {
	if m != nil {
		return m.MaxRewardByAddress
	}
	return types.Coin{}
}

func (m *RewardProgram) GetMinimumRolloverAmount() types.Coin {
	if m != nil {
		return m.MinimumRolloverAmount
	}
	return types.Coin{}
}

func (m *RewardProgram) GetClaimPeriodSeconds() uint64 {
	if m != nil {
		return m.ClaimPeriodSeconds
	}
	return 0
}

func (m *RewardProgram) GetProgramStartTime() time.Time {
	if m != nil {
		return m.ProgramStartTime
	}
	return time.Time{}
}

func (m *RewardProgram) GetExpectedProgramEndTime() time.Time {
	if m != nil {
		return m.ExpectedProgramEndTime
	}
	return time.Time{}
}

func (m *RewardProgram) GetProgramEndTimeMax() time.Time {
	if m != nil {
		return m.ProgramEndTimeMax
	}
	return time.Time{}
}

func (m *RewardProgram) GetClaimPeriodEndTime() time.Time {
	if m != nil {
		return m.ClaimPeriodEndTime
	}
	return time.Time{}
}

func (m *RewardProgram) GetActualProgramEndTime() time.Time {
	if m != nil {
		return m.ActualProgramEndTime
	}
	return time.Time{}
}

func (m *RewardProgram) GetClaimPeriods() uint64 {
	if m != nil {
		return m.ClaimPeriods
	}
	return 0
}

func (m *RewardProgram) GetCurrentClaimPeriod() uint64 {
	if m != nil {
		return m.CurrentClaimPeriod
	}
	return 0
}

func (m *RewardProgram) GetMaxRolloverClaimPeriods() uint64 {
	if m != nil {
		return m.MaxRolloverClaimPeriods
	}
	return 0
}

func (m *RewardProgram) GetState() RewardProgram_State {
	if m != nil {
		return m.State
	}
	return RewardProgram_STATE_UNSPECIFIED
}

func (m *RewardProgram) GetExpirationOffset() uint64 {
	if m != nil {
		return m.ExpirationOffset
	}
	return 0
}

func (m *RewardProgram) GetQualifyingActions() []QualifyingAction {
	if m != nil {
		return m.QualifyingActions
	}
	return nil
}

// ClaimPeriodRewardDistribution, this is updated at the end of every claim period.
type ClaimPeriodRewardDistribution struct {
	// The claim period id.
	ClaimPeriodId uint64 `protobuf:"varint,1,opt,name=claim_period_id,json=claimPeriodId,proto3" json:"claim_period_id,omitempty"`
	// The id of the reward program that this reward belongs to.
	RewardProgramId uint64 `protobuf:"varint,2,opt,name=reward_program_id,json=rewardProgramId,proto3" json:"reward_program_id,omitempty"`
	// The sum of all the granted rewards for this claim period.
	TotalRewardsPoolForClaimPeriod types.Coin `protobuf:"bytes,3,opt,name=total_rewards_pool_for_claim_period,json=totalRewardsPoolForClaimPeriod,proto3" json:"total_rewards_pool_for_claim_period"`
	// The final allocated rewards for this claim period.
	RewardsPool types.Coin `protobuf:"bytes,4,opt,name=rewards_pool,json=rewardsPool,proto3" json:"rewards_pool"`
	// The total number of granted shares for this claim period.
	TotalShares int64 `protobuf:"varint,5,opt,name=total_shares,json=totalShares,proto3" json:"total_shares,omitempty"`
	// A flag representing if the claim period for this reward has ended.
	ClaimPeriodEnded bool `protobuf:"varint,6,opt,name=claim_period_ended,json=claimPeriodEnded,proto3" json:"claim_period_ended,omitempty"`
}

func (m *ClaimPeriodRewardDistribution) Reset()         { *m = ClaimPeriodRewardDistribution{} }
func (m *ClaimPeriodRewardDistribution) String() string { return proto.CompactTextString(m) }
func (*ClaimPeriodRewardDistribution) ProtoMessage()    {}
func (*ClaimPeriodRewardDistribution) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{1}
}
func (m *ClaimPeriodRewardDistribution) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ClaimPeriodRewardDistribution) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ClaimPeriodRewardDistribution.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ClaimPeriodRewardDistribution) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ClaimPeriodRewardDistribution.Merge(m, src)
}
func (m *ClaimPeriodRewardDistribution) XXX_Size() int {
	return m.Size()
}
func (m *ClaimPeriodRewardDistribution) XXX_DiscardUnknown() {
	xxx_messageInfo_ClaimPeriodRewardDistribution.DiscardUnknown(m)
}

var xxx_messageInfo_ClaimPeriodRewardDistribution proto.InternalMessageInfo

func (m *ClaimPeriodRewardDistribution) GetClaimPeriodId() uint64 {
	if m != nil {
		return m.ClaimPeriodId
	}
	return 0
}

func (m *ClaimPeriodRewardDistribution) GetRewardProgramId() uint64 {
	if m != nil {
		return m.RewardProgramId
	}
	return 0
}

func (m *ClaimPeriodRewardDistribution) GetTotalRewardsPoolForClaimPeriod() types.Coin {
	if m != nil {
		return m.TotalRewardsPoolForClaimPeriod
	}
	return types.Coin{}
}

func (m *ClaimPeriodRewardDistribution) GetRewardsPool() types.Coin {
	if m != nil {
		return m.RewardsPool
	}
	return types.Coin{}
}

func (m *ClaimPeriodRewardDistribution) GetTotalShares() int64 {
	if m != nil {
		return m.TotalShares
	}
	return 0
}

func (m *ClaimPeriodRewardDistribution) GetClaimPeriodEnded() bool {
	if m != nil {
		return m.ClaimPeriodEnded
	}
	return false
}

// RewardAccountState contains state at the claim period level for a specific address.
type RewardAccountState struct {
	// The id of the reward program that this share belongs to.
	RewardProgramId uint64 `protobuf:"varint,1,opt,name=reward_program_id,json=rewardProgramId,proto3" json:"reward_program_id,omitempty"`
	// The id of the claim period that the share belongs to.
	ClaimPeriodId uint64 `protobuf:"varint,2,opt,name=claim_period_id,json=claimPeriodId,proto3" json:"claim_period_id,omitempty"`
	// Owner of the reward account state.
	Address string `protobuf:"bytes,3,opt,name=address,proto3" json:"address,omitempty"`
	// The number of actions performed by this account, mapped by action type.
	ActionCounter []*ActionCounter `protobuf:"bytes,4,rep,name=action_counter,json=actionCounter,proto3" json:"action_counter,omitempty"`
	// The amount of granted shares for the address in the reward program's claim period.
	SharesEarned uint64 `protobuf:"varint,5,opt,name=shares_earned,json=sharesEarned,proto3" json:"shares_earned,omitempty"`
	// The status of the claim.
	ClaimStatus RewardAccountState_ClaimStatus `protobuf:"varint,6,opt,name=claim_status,json=claimStatus,proto3,enum=provenance.reward.v1.RewardAccountState_ClaimStatus" json:"claim_status,omitempty"`
}

func (m *RewardAccountState) Reset()         { *m = RewardAccountState{} }
func (m *RewardAccountState) String() string { return proto.CompactTextString(m) }
func (*RewardAccountState) ProtoMessage()    {}
func (*RewardAccountState) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{2}
}
func (m *RewardAccountState) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *RewardAccountState) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_RewardAccountState.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *RewardAccountState) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RewardAccountState.Merge(m, src)
}
func (m *RewardAccountState) XXX_Size() int {
	return m.Size()
}
func (m *RewardAccountState) XXX_DiscardUnknown() {
	xxx_messageInfo_RewardAccountState.DiscardUnknown(m)
}

var xxx_messageInfo_RewardAccountState proto.InternalMessageInfo

func (m *RewardAccountState) GetRewardProgramId() uint64 {
	if m != nil {
		return m.RewardProgramId
	}
	return 0
}

func (m *RewardAccountState) GetClaimPeriodId() uint64 {
	if m != nil {
		return m.ClaimPeriodId
	}
	return 0
}

func (m *RewardAccountState) GetAddress() string {
	if m != nil {
		return m.Address
	}
	return ""
}

func (m *RewardAccountState) GetActionCounter() []*ActionCounter {
	if m != nil {
		return m.ActionCounter
	}
	return nil
}

func (m *RewardAccountState) GetSharesEarned() uint64 {
	if m != nil {
		return m.SharesEarned
	}
	return 0
}

func (m *RewardAccountState) GetClaimStatus() RewardAccountState_ClaimStatus {
	if m != nil {
		return m.ClaimStatus
	}
	return RewardAccountState_CLAIM_STATUS_UNSPECIFIED
}

// QualifyingAction can be one of many action types.
type QualifyingAction struct {
	// type of action to process
	//
	// Types that are valid to be assigned to Type:
	//	*QualifyingAction_Delegate
	//	*QualifyingAction_Transfer
	//	*QualifyingAction_Vote
	Type isQualifyingAction_Type `protobuf_oneof:"type"`
}

func (m *QualifyingAction) Reset()         { *m = QualifyingAction{} }
func (m *QualifyingAction) String() string { return proto.CompactTextString(m) }
func (*QualifyingAction) ProtoMessage()    {}
func (*QualifyingAction) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{3}
}
func (m *QualifyingAction) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *QualifyingAction) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_QualifyingAction.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *QualifyingAction) XXX_Merge(src proto.Message) {
	xxx_messageInfo_QualifyingAction.Merge(m, src)
}
func (m *QualifyingAction) XXX_Size() int {
	return m.Size()
}
func (m *QualifyingAction) XXX_DiscardUnknown() {
	xxx_messageInfo_QualifyingAction.DiscardUnknown(m)
}

var xxx_messageInfo_QualifyingAction proto.InternalMessageInfo

type isQualifyingAction_Type interface {
	isQualifyingAction_Type()
	Equal(interface{}) bool
	MarshalTo([]byte) (int, error)
	Size() int
}

type QualifyingAction_Delegate struct {
	Delegate *ActionDelegate `protobuf:"bytes,1,opt,name=delegate,proto3,oneof" json:"delegate,omitempty"`
}
type QualifyingAction_Transfer struct {
	Transfer *ActionTransfer `protobuf:"bytes,2,opt,name=transfer,proto3,oneof" json:"transfer,omitempty"`
}
type QualifyingAction_Vote struct {
	Vote *ActionVote `protobuf:"bytes,3,opt,name=vote,proto3,oneof" json:"vote,omitempty"`
}

func (*QualifyingAction_Delegate) isQualifyingAction_Type() {}
func (*QualifyingAction_Transfer) isQualifyingAction_Type() {}
func (*QualifyingAction_Vote) isQualifyingAction_Type()     {}

func (m *QualifyingAction) GetType() isQualifyingAction_Type {
	if m != nil {
		return m.Type
	}
	return nil
}

func (m *QualifyingAction) GetDelegate() *ActionDelegate {
	if x, ok := m.GetType().(*QualifyingAction_Delegate); ok {
		return x.Delegate
	}
	return nil
}

func (m *QualifyingAction) GetTransfer() *ActionTransfer {
	if x, ok := m.GetType().(*QualifyingAction_Transfer); ok {
		return x.Transfer
	}
	return nil
}

func (m *QualifyingAction) GetVote() *ActionVote {
	if x, ok := m.GetType().(*QualifyingAction_Vote); ok {
		return x.Vote
	}
	return nil
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*QualifyingAction) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*QualifyingAction_Delegate)(nil),
		(*QualifyingAction_Transfer)(nil),
		(*QualifyingAction_Vote)(nil),
	}
}

// QualifyingActions contains a list of QualifyingActions.
type QualifyingActions struct {
	// The actions that count towards the reward.
	QualifyingActions []QualifyingAction `protobuf:"bytes,1,rep,name=qualifying_actions,json=qualifyingActions,proto3" json:"qualifying_actions"`
}

func (m *QualifyingActions) Reset()         { *m = QualifyingActions{} }
func (m *QualifyingActions) String() string { return proto.CompactTextString(m) }
func (*QualifyingActions) ProtoMessage()    {}
func (*QualifyingActions) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{4}
}
func (m *QualifyingActions) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *QualifyingActions) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_QualifyingActions.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *QualifyingActions) XXX_Merge(src proto.Message) {
	xxx_messageInfo_QualifyingActions.Merge(m, src)
}
func (m *QualifyingActions) XXX_Size() int {
	return m.Size()
}
func (m *QualifyingActions) XXX_DiscardUnknown() {
	xxx_messageInfo_QualifyingActions.DiscardUnknown(m)
}

var xxx_messageInfo_QualifyingActions proto.InternalMessageInfo

func (m *QualifyingActions) GetQualifyingActions() []QualifyingAction {
	if m != nil {
		return m.QualifyingActions
	}
	return nil
}

// ActionDelegate represents the delegate action and its required eligibility criteria.
type ActionDelegate struct {
	// Minimum number of successful delegates.
	MinimumActions uint64 `protobuf:"varint,1,opt,name=minimum_actions,json=minimumActions,proto3" json:"minimum_actions,omitempty"`
	// Maximum number of successful delegates.
	MaximumActions uint64 `protobuf:"varint,2,opt,name=maximum_actions,json=maximumActions,proto3" json:"maximum_actions,omitempty"`
	// Minimum amount that the user must have currently delegated on the validator.
	MinimumDelegationAmount *types.Coin `protobuf:"bytes,3,opt,name=minimum_delegation_amount,json=minimumDelegationAmount,proto3" json:"minimum_delegation_amount,omitempty"`
	// Maximum amount that the user must have currently delegated on the validator.
	MaximumDelegationAmount *types.Coin `protobuf:"bytes,4,opt,name=maximum_delegation_amount,json=maximumDelegationAmount,proto3" json:"maximum_delegation_amount,omitempty"`
	// Minimum percentile that can be below the validator's power ranking.
	MinimumActiveStakePercentile github_com_cosmos_cosmos_sdk_types.Dec `protobuf:"bytes,5,opt,name=minimum_active_stake_percentile,json=minimumActiveStakePercentile,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Dec" json:"minimum_active_stake_percentile"`
	// Maximum percentile that can be below the validator's power ranking.
	MaximumActiveStakePercentile github_com_cosmos_cosmos_sdk_types.Dec `protobuf:"bytes,6,opt,name=maximum_active_stake_percentile,json=maximumActiveStakePercentile,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Dec" json:"maximum_active_stake_percentile"`
}

func (m *ActionDelegate) Reset()         { *m = ActionDelegate{} }
func (m *ActionDelegate) String() string { return proto.CompactTextString(m) }
func (*ActionDelegate) ProtoMessage()    {}
func (*ActionDelegate) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{5}
}
func (m *ActionDelegate) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ActionDelegate) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ActionDelegate.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ActionDelegate) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ActionDelegate.Merge(m, src)
}
func (m *ActionDelegate) XXX_Size() int {
	return m.Size()
}
func (m *ActionDelegate) XXX_DiscardUnknown() {
	xxx_messageInfo_ActionDelegate.DiscardUnknown(m)
}

var xxx_messageInfo_ActionDelegate proto.InternalMessageInfo

func (m *ActionDelegate) GetMinimumActions() uint64 {
	if m != nil {
		return m.MinimumActions
	}
	return 0
}

func (m *ActionDelegate) GetMaximumActions() uint64 {
	if m != nil {
		return m.MaximumActions
	}
	return 0
}

func (m *ActionDelegate) GetMinimumDelegationAmount() *types.Coin {
	if m != nil {
		return m.MinimumDelegationAmount
	}
	return nil
}

func (m *ActionDelegate) GetMaximumDelegationAmount() *types.Coin {
	if m != nil {
		return m.MaximumDelegationAmount
	}
	return nil
}

// ActionTransfer represents the transfer action and its required eligibility criteria.
type ActionTransfer struct {
	// Minimum number of successful transfers.
	MinimumActions uint64 `protobuf:"varint,1,opt,name=minimum_actions,json=minimumActions,proto3" json:"minimum_actions,omitempty"`
	// Maximum number of successful transfers.
	MaximumActions uint64 `protobuf:"varint,2,opt,name=maximum_actions,json=maximumActions,proto3" json:"maximum_actions,omitempty"`
	// Minimum delegation amount the account must have across all validators, for the transfer action to be counted.
	MinimumDelegationAmount types.Coin `protobuf:"bytes,3,opt,name=minimum_delegation_amount,json=minimumDelegationAmount,proto3" json:"minimum_delegation_amount"`
}

func (m *ActionTransfer) Reset()         { *m = ActionTransfer{} }
func (m *ActionTransfer) String() string { return proto.CompactTextString(m) }
func (*ActionTransfer) ProtoMessage()    {}
func (*ActionTransfer) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{6}
}
func (m *ActionTransfer) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ActionTransfer) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ActionTransfer.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ActionTransfer) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ActionTransfer.Merge(m, src)
}
func (m *ActionTransfer) XXX_Size() int {
	return m.Size()
}
func (m *ActionTransfer) XXX_DiscardUnknown() {
	xxx_messageInfo_ActionTransfer.DiscardUnknown(m)
}

var xxx_messageInfo_ActionTransfer proto.InternalMessageInfo

func (m *ActionTransfer) GetMinimumActions() uint64 {
	if m != nil {
		return m.MinimumActions
	}
	return 0
}

func (m *ActionTransfer) GetMaximumActions() uint64 {
	if m != nil {
		return m.MaximumActions
	}
	return 0
}

func (m *ActionTransfer) GetMinimumDelegationAmount() types.Coin {
	if m != nil {
		return m.MinimumDelegationAmount
	}
	return types.Coin{}
}

// ActionVote represents the voting action and its required eligibility criteria.
type ActionVote struct {
	// Minimum number of successful votes.
	MinimumActions uint64 `protobuf:"varint,1,opt,name=minimum_actions,json=minimumActions,proto3" json:"minimum_actions,omitempty"`
	// Maximum number of successful votes.
	MaximumActions uint64 `protobuf:"varint,2,opt,name=maximum_actions,json=maximumActions,proto3" json:"maximum_actions,omitempty"`
	// Minimum delegation amount the account must have across all validators, for the vote action to be counted.
	MinimumDelegationAmount types.Coin `protobuf:"bytes,3,opt,name=minimum_delegation_amount,json=minimumDelegationAmount,proto3" json:"minimum_delegation_amount"`
	// Positive multiplier that is applied to the shares awarded by the vote action when conditions
	// are met(for now the only condition is the current vote is a validator vote). A value of zero will behave the same as one
	ValidatorMultiplier uint64 `protobuf:"varint,4,opt,name=validator_multiplier,json=validatorMultiplier,proto3" json:"validator_multiplier,omitempty"`
}

func (m *ActionVote) Reset()         { *m = ActionVote{} }
func (m *ActionVote) String() string { return proto.CompactTextString(m) }
func (*ActionVote) ProtoMessage()    {}
func (*ActionVote) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{7}
}
func (m *ActionVote) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ActionVote) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ActionVote.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ActionVote) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ActionVote.Merge(m, src)
}
func (m *ActionVote) XXX_Size() int {
	return m.Size()
}
func (m *ActionVote) XXX_DiscardUnknown() {
	xxx_messageInfo_ActionVote.DiscardUnknown(m)
}

var xxx_messageInfo_ActionVote proto.InternalMessageInfo

func (m *ActionVote) GetMinimumActions() uint64 {
	if m != nil {
		return m.MinimumActions
	}
	return 0
}

func (m *ActionVote) GetMaximumActions() uint64 {
	if m != nil {
		return m.MaximumActions
	}
	return 0
}

func (m *ActionVote) GetMinimumDelegationAmount() types.Coin {
	if m != nil {
		return m.MinimumDelegationAmount
	}
	return types.Coin{}
}

func (m *ActionVote) GetValidatorMultiplier() uint64 {
	if m != nil {
		return m.ValidatorMultiplier
	}
	return 0
}

// ActionCounter is a key-value pair that maps action type to the number of times it was performed.
type ActionCounter struct {
	// The type of action performed.
	ActionType string `protobuf:"bytes,1,opt,name=action_type,json=actionType,proto3" json:"action_type,omitempty"`
	// The number of times this action has been performed
	NumberOfActions uint64 `protobuf:"varint,2,opt,name=number_of_actions,json=numberOfActions,proto3" json:"number_of_actions,omitempty"`
}

func (m *ActionCounter) Reset()         { *m = ActionCounter{} }
func (m *ActionCounter) String() string { return proto.CompactTextString(m) }
func (*ActionCounter) ProtoMessage()    {}
func (*ActionCounter) Descriptor() ([]byte, []int) {
	return fileDescriptor_0c3894741a216575, []int{8}
}
func (m *ActionCounter) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ActionCounter) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ActionCounter.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ActionCounter) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ActionCounter.Merge(m, src)
}
func (m *ActionCounter) XXX_Size() int {
	return m.Size()
}
func (m *ActionCounter) XXX_DiscardUnknown() {
	xxx_messageInfo_ActionCounter.DiscardUnknown(m)
}

var xxx_messageInfo_ActionCounter proto.InternalMessageInfo

func (m *ActionCounter) GetActionType() string {
	if m != nil {
		return m.ActionType
	}
	return ""
}

func (m *ActionCounter) GetNumberOfActions() uint64 {
	if m != nil {
		return m.NumberOfActions
	}
	return 0
}

func init() {
	proto.RegisterEnum("provenance.reward.v1.RewardProgram_State", RewardProgram_State_name, RewardProgram_State_value)
	proto.RegisterEnum("provenance.reward.v1.RewardAccountState_ClaimStatus", RewardAccountState_ClaimStatus_name, RewardAccountState_ClaimStatus_value)
	proto.RegisterType((*RewardProgram)(nil), "provenance.reward.v1.RewardProgram")
	proto.RegisterType((*ClaimPeriodRewardDistribution)(nil), "provenance.reward.v1.ClaimPeriodRewardDistribution")
	proto.RegisterType((*RewardAccountState)(nil), "provenance.reward.v1.RewardAccountState")
	proto.RegisterType((*QualifyingAction)(nil), "provenance.reward.v1.QualifyingAction")
	proto.RegisterType((*QualifyingActions)(nil), "provenance.reward.v1.QualifyingActions")
	proto.RegisterType((*ActionDelegate)(nil), "provenance.reward.v1.ActionDelegate")
	proto.RegisterType((*ActionTransfer)(nil), "provenance.reward.v1.ActionTransfer")
	proto.RegisterType((*ActionVote)(nil), "provenance.reward.v1.ActionVote")
	proto.RegisterType((*ActionCounter)(nil), "provenance.reward.v1.ActionCounter")
}

func init() { proto.RegisterFile("provenance/reward/v1/reward.proto", fileDescriptor_0c3894741a216575) }

var fileDescriptor_0c3894741a216575 = []byte{
	// 1461 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xd4, 0x57, 0xbd, 0x73, 0xdb, 0xc6,
	0x12, 0x17, 0x24, 0x4a, 0x96, 0x96, 0x22, 0x45, 0x9e, 0x29, 0x0b, 0xd6, 0xf8, 0x91, 0xb2, 0xfc,
	0xc6, 0x4f, 0xef, 0xbd, 0x18, 0x8c, 0x94, 0x8c, 0x8b, 0xa4, 0xc8, 0x90, 0x22, 0x15, 0x33, 0xb1,
	0x65, 0x05, 0xa4, 0xe2, 0x4c, 0x5c, 0x60, 0x8e, 0xc0, 0x91, 0xc6, 0x18, 0xc0, 0xd1, 0xc0, 0x91,
	0xa1, 0xba, 0x94, 0x29, 0x5d, 0x26, 0x9d, 0xff, 0x1c, 0xa7, 0x73, 0x99, 0x49, 0xe1, 0x64, 0xec,
	0x14, 0xa9, 0x5d, 0xa5, 0xcc, 0xdc, 0x07, 0x48, 0x90, 0xa2, 0x6d, 0x29, 0x1f, 0x45, 0x2a, 0xe9,
	0x6e, 0x77, 0x7f, 0xfb, 0x71, 0xbf, 0xdd, 0x05, 0xe1, 0x6a, 0x2f, 0xa4, 0x03, 0x12, 0xe0, 0xc0,
	0x26, 0xe5, 0x90, 0x7c, 0x85, 0x43, 0xa7, 0x3c, 0xd8, 0x55, 0xff, 0x19, 0xbd, 0x90, 0x32, 0x8a,
	0x0a, 0x63, 0x15, 0x43, 0x09, 0x06, 0xbb, 0x9b, 0x85, 0x2e, 0xed, 0x52, 0xa1, 0x50, 0xe6, 0xff,
	0x49, 0xdd, 0xcd, 0x52, 0x97, 0xd2, 0xae, 0x47, 0xca, 0xe2, 0xd4, 0xee, 0x77, 0xca, 0xcc, 0xf5,
	0x49, 0xc4, 0xb0, 0xdf, 0x53, 0x0a, 0x45, 0x9b, 0x46, 0x3e, 0x8d, 0xca, 0x6d, 0x1c, 0x91, 0xf2,
	0x60, 0xb7, 0x4d, 0x18, 0xde, 0x2d, 0xdb, 0xd4, 0x0d, 0xa4, 0x7c, 0xfb, 0x55, 0x1a, 0x32, 0xa6,
	0x70, 0x72, 0x14, 0xd2, 0x6e, 0x88, 0x7d, 0x94, 0x85, 0x79, 0xd7, 0xd1, 0xb5, 0x2d, 0x6d, 0x27,
	0x65, 0xce, 0xbb, 0x0e, 0x2a, 0xc0, 0x22, 0x73, 0x99, 0x47, 0xf4, 0xf9, 0x2d, 0x6d, 0x67, 0xc5,
	0x94, 0x07, 0xb4, 0x05, 0x69, 0x87, 0x44, 0x76, 0xe8, 0xf6, 0x98, 0x4b, 0x03, 0x7d, 0x41, 0xc8,
	0x92, 0x57, 0xe8, 0x26, 0x6c, 0x38, 0x6e, 0xc4, 0x42, 0xb7, 0xdd, 0x67, 0xc4, 0xea, 0x84, 0xd4,
	0xb7, 0xb0, 0xe3, 0x84, 0x24, 0x8a, 0xf4, 0x94, 0xd0, 0x5e, 0x1f, 0x8b, 0x0f, 0x42, 0xea, 0x57,
	0xa4, 0x10, 0x7d, 0x0a, 0x79, 0x46, 0x19, 0xf6, 0x2c, 0x99, 0xbb, 0xd5, 0xa3, 0xd4, 0xd3, 0x17,
	0xb7, 0xb4, 0x9d, 0xf4, 0xde, 0x65, 0x43, 0x66, 0x63, 0xf0, 0x6c, 0x0c, 0x95, 0x8d, 0xb1, 0x4f,
	0xdd, 0xa0, 0x9a, 0x7a, 0xfa, 0xbc, 0x34, 0x67, 0xae, 0x09, 0x4b, 0x95, 0x0f, 0xa5, 0x1e, 0x3a,
	0x86, 0x4b, 0x21, 0xf1, 0xb1, 0x1b, 0xb8, 0x41, 0x57, 0x20, 0x59, 0x6d, 0xec, 0xf1, 0xca, 0xea,
	0x4b, 0x67, 0x43, 0x2c, 0x8c, 0xcc, 0x39, 0x5e, 0x55, 0x1a, 0xa3, 0x03, 0xc8, 0xda, 0x1e, 0x76,
	0x7d, 0xe2, 0x58, 0xd8, 0xa7, 0xfd, 0x80, 0xe9, 0x17, 0xce, 0x06, 0x97, 0x51, 0x66, 0x15, 0x61,
	0x85, 0x4c, 0x58, 0xf7, 0xf1, 0x30, 0xce, 0xb4, 0x7d, 0x32, 0xaa, 0xd0, 0xf2, 0xd9, 0xe0, 0x90,
	0x8f, 0x87, 0x32, 0xdb, 0xea, 0x49, 0x5c, 0xbf, 0x7b, 0xb0, 0xe1, 0xbb, 0x81, 0xeb, 0xf7, 0x7d,
	0x2b, 0xa4, 0x9e, 0x47, 0x07, 0x24, 0x8c, 0x83, 0x5c, 0x39, 0x1b, 0xea, 0xba, 0xb2, 0x37, 0x95,
	0xb9, 0x0a, 0xf6, 0x5d, 0x28, 0x88, 0xe8, 0xad, 0x1e, 0x09, 0x5d, 0xea, 0x58, 0x11, 0xb1, 0x69,
	0xe0, 0x44, 0x3a, 0x08, 0xaa, 0x20, 0x21, 0x3b, 0x12, 0xa2, 0xa6, 0x94, 0x20, 0x13, 0x50, 0x4f,
	0xb2, 0xca, 0x8a, 0x18, 0x0e, 0x99, 0xc5, 0xd9, 0xa9, 0xa7, 0x45, 0x14, 0x9b, 0x86, 0xa4, 0xae,
	0x11, 0x53, 0xd7, 0x68, 0xc5, 0xd4, 0xad, 0x2e, 0xf3, 0x30, 0x1e, 0xff, 0x54, 0xd2, 0xcc, 0x9c,
	0xb2, 0x6f, 0x72, 0x73, 0xae, 0x80, 0x2c, 0xb8, 0x4c, 0x86, 0x3d, 0x62, 0x33, 0xe2, 0x58, 0x31,
	0x38, 0x09, 0x1c, 0x09, 0xbd, 0x7a, 0x0e, 0xe8, 0x4b, 0x31, 0x8c, 0x22, 0x7e, 0x3d, 0x70, 0x84,
	0x83, 0x63, 0x28, 0x4c, 0xe3, 0x5a, 0x3e, 0x1e, 0xea, 0x99, 0x73, 0x60, 0xe7, 0x7b, 0x13, 0x98,
	0x77, 0xf0, 0x10, 0xdd, 0x83, 0xf5, 0x89, 0xea, 0x8d, 0x62, 0xce, 0x9e, 0x03, 0x37, 0x59, 0xe4,
	0x38, 0xde, 0xfb, 0xb0, 0x81, 0x6d, 0xd6, 0xc7, 0xde, 0xe9, 0x72, 0xac, 0x9d, 0x03, 0xba, 0x20,
	0x41, 0xa6, 0x8a, 0x71, 0x0d, 0x32, 0xc9, 0xa8, 0x23, 0x3d, 0x27, 0x1e, 0x7b, 0x35, 0x11, 0x47,
	0x24, 0x88, 0xd1, 0x0f, 0x43, 0x12, 0x30, 0x2b, 0xa9, 0xac, 0xe7, 0x15, 0x31, 0xa4, 0x6c, 0x7f,
	0x6c, 0x82, 0x3e, 0x84, 0x4d, 0xc1, 0xfb, 0x98, 0x9f, 0x93, 0x3e, 0x90, 0xb0, 0xdb, 0xe0, 0xdc,
	0x56, 0x0a, 0xfb, 0x49, 0x77, 0x1f, 0xc1, 0x62, 0xc4, 0x30, 0x23, 0xfa, 0xc5, 0x2d, 0x6d, 0x27,
	0xbb, 0xf7, 0x5f, 0x63, 0xd6, 0xbc, 0x34, 0x26, 0x86, 0x9a, 0xd1, 0xe4, 0x06, 0xa6, 0xb4, 0x43,
	0xff, 0x87, 0x3c, 0x19, 0xf6, 0xdc, 0x10, 0xf3, 0x39, 0x65, 0xd1, 0x4e, 0x27, 0x22, 0x4c, 0x2f,
	0x08, 0xa7, 0xb9, 0xb1, 0xe0, 0xae, 0xb8, 0x47, 0xf7, 0x01, 0x3d, 0xea, 0x63, 0xcf, 0xed, 0x9c,
	0xf0, 0x11, 0x82, 0x6d, 0x2e, 0x8a, 0xf4, 0xf5, 0xad, 0x85, 0x9d, 0xf4, 0xde, 0xf5, 0xd9, 0xae,
	0x3f, 0x1b, 0xe9, 0x57, 0x84, 0xba, 0x6a, 0xab, 0xfc, 0xa3, 0xa9, 0xfb, 0x68, 0xfb, 0x21, 0x2c,
	0x8a, 0xc8, 0xd0, 0x3a, 0xe4, 0x9b, 0xad, 0x4a, 0xab, 0x6e, 0x1d, 0x1f, 0x36, 0x8f, 0xea, 0xfb,
	0x8d, 0x83, 0x46, 0xbd, 0x96, 0x9b, 0x43, 0x79, 0xc8, 0xc8, 0xeb, 0xa3, 0xfa, 0x61, 0xad, 0x71,
	0xf8, 0x71, 0x4e, 0x1b, 0x5f, 0x35, 0x5b, 0x15, 0xb3, 0x55, 0xaf, 0xe5, 0xe6, 0x11, 0x82, 0xac,
	0xbc, 0x3a, 0x68, 0x1c, 0x36, 0x9a, 0xb7, 0xea, 0xb5, 0xdc, 0xc2, 0x58, 0xad, 0xfe, 0xc5, 0x51,
	0xc3, 0xac, 0xd7, 0x72, 0xa9, 0x0f, 0x96, 0xbf, 0x7d, 0x52, 0xd2, 0x7e, 0x7d, 0x52, 0xd2, 0xb6,
	0xbf, 0x5e, 0x80, 0x7f, 0x25, 0x4a, 0x2a, 0x4b, 0x55, 0x8b, 0xa7, 0x31, 0x1f, 0xde, 0xd7, 0x61,
	0x6d, 0x82, 0xad, 0xa3, 0x8d, 0x90, 0x49, 0xbc, 0x7c, 0xc3, 0x41, 0xff, 0x83, 0x7c, 0x3c, 0xa6,
	0x15, 0xf9, 0x5c, 0x47, 0x2c, 0x8a, 0x94, 0xb9, 0x16, 0x26, 0x5f, 0xa0, 0xe1, 0x20, 0x0f, 0xae,
	0x25, 0x07, 0x7b, 0x24, 0xe7, 0x71, 0x87, 0x4e, 0x3e, 0xbf, 0x58, 0x25, 0x67, 0x18, 0x52, 0xc5,
	0xc4, 0xa8, 0x8f, 0xf8, 0x6c, 0x3e, 0xa0, 0x49, 0x9a, 0xa0, 0x2a, 0xac, 0x26, 0xfd, 0x88, 0x9d,
	0x73, 0x06, 0xd8, 0x74, 0x38, 0x46, 0x44, 0x57, 0x61, 0x55, 0x46, 0x1c, 0x3d, 0xc0, 0x21, 0x89,
	0xc4, 0x16, 0x5a, 0x30, 0xd3, 0xe2, 0xae, 0x29, 0xae, 0xd0, 0x3b, 0x80, 0xa6, 0xdb, 0x9a, 0x38,
	0x62, 0xb9, 0x2c, 0x9b, 0xb9, 0xc9, 0x6e, 0x25, 0x4e, 0xe2, 0x09, 0x5e, 0x2d, 0x00, 0x92, 0xc1,
	0x57, 0x6c, 0x9b, 0x8f, 0x57, 0xc9, 0x83, 0x99, 0xf5, 0xd4, 0x66, 0xd7, 0x73, 0xc6, 0x1b, 0xcd,
	0xcf, 0x7a, 0x23, 0x1d, 0x2e, 0xc4, 0x6b, 0x45, 0xae, 0xe9, 0xf8, 0x88, 0x3e, 0x81, 0xac, 0x24,
	0xb4, 0x25, 0x42, 0x20, 0xa1, 0x9e, 0x12, 0xbc, 0xbe, 0x36, 0x9b, 0xd7, 0x92, 0xb5, 0xfb, 0x52,
	0xd5, 0xcc, 0xe0, 0xe4, 0x91, 0x4f, 0x0a, 0x59, 0x25, 0x8b, 0xe0, 0x30, 0x20, 0x8e, 0x28, 0x56,
	0xca, 0x5c, 0x95, 0x97, 0x75, 0x71, 0x87, 0xee, 0x81, 0x9c, 0x1c, 0x7c, 0x1d, 0xb0, 0x7e, 0x24,
	0xea, 0x94, 0xdd, 0x7b, 0xff, 0x4d, 0x1d, 0x9c, 0x2c, 0x8f, 0x21, 0x1e, 0xb8, 0x29, 0x6c, 0xcd,
	0xb4, 0x3d, 0x3e, 0x6c, 0x7f, 0xa7, 0x41, 0x3a, 0x21, 0x44, 0x57, 0x40, 0xdf, 0xbf, 0x5d, 0x69,
	0xdc, 0xe1, 0x5d, 0xd2, 0x3a, 0x6e, 0x4e, 0xb5, 0xd5, 0x69, 0xa9, 0x38, 0x56, 0xaa, 0xb7, 0xeb,
	0x39, 0x0d, 0x6d, 0xc2, 0xa5, 0x09, 0xe9, 0x58, 0x36, 0x8f, 0x74, 0x28, 0x9c, 0x96, 0x89, 0x86,
	0x9b, 0x96, 0xcc, 0xea, 0xbb, 0x5f, 0x34, 0xc8, 0x4d, 0x0f, 0x07, 0x54, 0x85, 0x65, 0x87, 0x78,
	0xa4, 0xcb, 0x27, 0x9a, 0x26, 0x48, 0xfa, 0xef, 0x37, 0x95, 0xbf, 0xa6, 0x74, 0x6f, 0xcd, 0x99,
	0x23, 0x3b, 0x8e, 0xc1, 0x42, 0x1c, 0x44, 0x1d, 0x12, 0x0a, 0x0e, 0xbc, 0x05, 0xa3, 0xa5, 0x74,
	0x39, 0x46, 0x6c, 0x87, 0x6e, 0x42, 0x6a, 0x40, 0x19, 0x51, 0xfd, 0xb7, 0xf5, 0x26, 0xfb, 0xcf,
	0xa9, 0xf0, 0x2f, 0xf4, 0xc7, 0xe9, 0x55, 0x97, 0x20, 0xc5, 0x4e, 0x7a, 0x64, 0xbb, 0x07, 0xf9,
	0xe9, 0x2c, 0xa3, 0xd7, 0xcc, 0x51, 0xed, 0xaf, 0x99, 0xa3, 0xdf, 0xa4, 0x20, 0x3b, 0x59, 0x1e,
	0xf4, 0x1f, 0x58, 0x8b, 0x3f, 0x83, 0xc6, 0xce, 0x38, 0x23, 0xb3, 0xea, 0x3a, 0x0e, 0x8c, 0x2b,
	0xe2, 0xe1, 0x84, 0xe2, 0xbc, 0x52, 0x94, 0xd7, 0xb1, 0xe2, 0x31, 0x5c, 0x8e, 0x11, 0x55, 0xe1,
	0x79, 0xe7, 0xa8, 0x4f, 0xab, 0xb7, 0x4d, 0x2d, 0x33, 0xfe, 0x28, 0xab, 0x8d, 0x4c, 0xd5, 0x67,
	0x15, 0x87, 0x55, 0xfe, 0x4f, 0xc3, 0xa6, 0xde, 0x0e, 0x2b, 0x6d, 0x4f, 0xc1, 0xf6, 0xa1, 0x94,
	0xcc, 0x7f, 0x40, 0x78, 0xcf, 0x3d, 0x24, 0x7c, 0x58, 0xd8, 0x24, 0x60, 0xae, 0x47, 0x44, 0x87,
	0xae, 0x54, 0x0d, 0x5e, 0xd4, 0x1f, 0x9f, 0x97, 0xae, 0x77, 0x5d, 0xf6, 0xa0, 0xdf, 0x36, 0x6c,
	0xea, 0x97, 0xd5, 0x8f, 0x06, 0xf9, 0xe7, 0x46, 0xe4, 0x3c, 0x2c, 0xf3, 0x87, 0x8d, 0x8c, 0x1a,
	0xb1, 0xcd, 0x2b, 0x89, 0xfa, 0x0d, 0x48, 0x93, 0x83, 0x1e, 0x8d, 0x30, 0x85, 0xdb, 0x44, 0x35,
	0x67, 0xb9, 0x5d, 0xfa, 0x83, 0x6e, 0xc7, 0xaf, 0x71, 0xca, 0x6d, 0xa2, 0xc7, 0xbe, 0xd7, 0x62,
	0x2a, 0xc4, 0x2c, 0xff, 0x1b, 0xa8, 0x70, 0xff, 0xcf, 0x50, 0x41, 0xd1, 0xf8, 0x75, 0x84, 0x48,
	0xe4, 0xf2, 0x9b, 0x06, 0x30, 0xee, 0xb8, 0x7f, 0x58, 0x1e, 0x68, 0x17, 0x0a, 0x03, 0xec, 0xb9,
	0x0e, 0x66, 0x34, 0xb4, 0xfc, 0xbe, 0xc7, 0xdc, 0x9e, 0xe7, 0x8a, 0x1d, 0xc3, 0x43, 0xb9, 0x38,
	0x92, 0xdd, 0x19, 0x89, 0x12, 0xa9, 0x77, 0x20, 0x33, 0xb1, 0x6e, 0x50, 0x09, 0xd2, 0x6a, 0x57,
	0x71, 0x4e, 0x88, 0xc4, 0x57, 0x4c, 0x90, 0x57, 0xad, 0x93, 0x9e, 0x58, 0x9d, 0x41, 0xdf, 0x6f,
	0x93, 0xd0, 0xa2, 0x9d, 0xa9, 0xb4, 0xd7, 0xa4, 0xe0, 0x6e, 0x47, 0xe5, 0x9d, 0x98, 0x59, 0xdd,
	0xa7, 0x2f, 0x8a, 0xda, 0xb3, 0x17, 0x45, 0xed, 0xe7, 0x17, 0x45, 0xed, 0xf1, 0xcb, 0xe2, 0xdc,
	0xb3, 0x97, 0xc5, 0xb9, 0x1f, 0x5e, 0x16, 0xe7, 0x60, 0xc3, 0xa5, 0x33, 0xc7, 0xd2, 0x91, 0xf6,
	0xe5, 0x5e, 0x82, 0xb3, 0x63, 0x95, 0x1b, 0x2e, 0x4d, 0x9c, 0xca, 0xc3, 0xf8, 0xf7, 0xbd, 0xe0,
	0x70, 0x7b, 0x49, 0x7c, 0x7d, 0xbf, 0xf7, 0x7b, 0x00, 0x00, 0x00, 0xff, 0xff, 0x96, 0xea, 0xde,
	0xc7, 0x01, 0x10, 0x00, 0x00,
}

func (this *RewardProgram) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RewardProgram)
	if !ok {
		that2, ok := that.(RewardProgram)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Id != that1.Id {
		return false
	}
	if this.Title != that1.Title {
		return false
	}
	if this.Description != that1.Description {
		return false
	}
	if this.DistributeFromAddress != that1.DistributeFromAddress {
		return false
	}
	if !this.TotalRewardPool.Equal(&that1.TotalRewardPool) {
		return false
	}
	if !this.RemainingPoolBalance.Equal(&that1.RemainingPoolBalance) {
		return false
	}
	if !this.ClaimedAmount.Equal(&that1.ClaimedAmount) {
		return false
	}
	if !this.MaxRewardByAddress.Equal(&that1.MaxRewardByAddress) {
		return false
	}
	if !this.MinimumRolloverAmount.Equal(&that1.MinimumRolloverAmount) {
		return false
	}
	if this.ClaimPeriodSeconds != that1.ClaimPeriodSeconds {
		return false
	}
	if !this.ProgramStartTime.Equal(that1.ProgramStartTime) {
		return false
	}
	if !this.ExpectedProgramEndTime.Equal(that1.ExpectedProgramEndTime) {
		return false
	}
	if !this.ProgramEndTimeMax.Equal(that1.ProgramEndTimeMax) {
		return false
	}
	if !this.ClaimPeriodEndTime.Equal(that1.ClaimPeriodEndTime) {
		return false
	}
	if !this.ActualProgramEndTime.Equal(that1.ActualProgramEndTime) {
		return false
	}
	if this.ClaimPeriods != that1.ClaimPeriods {
		return false
	}
	if this.CurrentClaimPeriod != that1.CurrentClaimPeriod {
		return false
	}
	if this.MaxRolloverClaimPeriods != that1.MaxRolloverClaimPeriods {
		return false
	}
	if this.State != that1.State {
		return false
	}
	if this.ExpirationOffset != that1.ExpirationOffset {
		return false
	}
	if len(this.QualifyingActions) != len(that1.QualifyingActions) {
		return false
	}
	for i := range this.QualifyingActions {
		if !this.QualifyingActions[i].Equal(&that1.QualifyingActions[i]) {
			return false
		}
	}
	return true
}
func (this *ClaimPeriodRewardDistribution) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*ClaimPeriodRewardDistribution)
	if !ok {
		that2, ok := that.(ClaimPeriodRewardDistribution)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.ClaimPeriodId != that1.ClaimPeriodId {
		return false
	}
	if this.RewardProgramId != that1.RewardProgramId {
		return false
	}
	if !this.TotalRewardsPoolForClaimPeriod.Equal(&that1.TotalRewardsPoolForClaimPeriod) {
		return false
	}
	if !this.RewardsPool.Equal(&that1.RewardsPool) {
		return false
	}
	if this.TotalShares != that1.TotalShares {
		return false
	}
	if this.ClaimPeriodEnded != that1.ClaimPeriodEnded {
		return false
	}
	return true
}
func (this *RewardAccountState) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RewardAccountState)
	if !ok {
		that2, ok := that.(RewardAccountState)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.RewardProgramId != that1.RewardProgramId {
		return false
	}
	if this.ClaimPeriodId != that1.ClaimPeriodId {
		return false
	}
	if this.Address != that1.Address {
		return false
	}
	if len(this.ActionCounter) != len(that1.ActionCounter) {
		return false
	}
	for i := range this.ActionCounter {
		if !this.ActionCounter[i].Equal(that1.ActionCounter[i]) {
			return false
		}
	}
	if this.SharesEarned != that1.SharesEarned {
		return false
	}
	if this.ClaimStatus != that1.ClaimStatus {
		return false
	}
	return true
}
func (this *QualifyingAction) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*QualifyingAction)
	if !ok {
		that2, ok := that.(QualifyingAction)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if that1.Type == nil {
		if this.Type != nil {
			return false
		}
	} else if this.Type == nil {
		return false
	} else if !this.Type.Equal(that1.Type) {
		return false
	}
	return true
}
func (this *QualifyingAction_Delegate) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*QualifyingAction_Delegate)
	if !ok {
		that2, ok := that.(QualifyingAction_Delegate)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Delegate.Equal(that1.Delegate) {
		return false
	}
	return true
}
func (this *QualifyingAction_Transfer) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*QualifyingAction_Transfer)
	if !ok {
		that2, ok := that.(QualifyingAction_Transfer)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Transfer.Equal(that1.Transfer) {
		return false
	}
	return true
}
func (this *QualifyingAction_Vote) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*QualifyingAction_Vote)
	if !ok {
		that2, ok := that.(QualifyingAction_Vote)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Vote.Equal(that1.Vote) {
		return false
	}
	return true
}
func (this *ActionDelegate) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*ActionDelegate)
	if !ok {
		that2, ok := that.(ActionDelegate)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.MinimumActions != that1.MinimumActions {
		return false
	}
	if this.MaximumActions != that1.MaximumActions {
		return false
	}
	if !this.MinimumDelegationAmount.Equal(that1.MinimumDelegationAmount) {
		return false
	}
	if !this.MaximumDelegationAmount.Equal(that1.MaximumDelegationAmount) {
		return false
	}
	if !this.MinimumActiveStakePercentile.Equal(that1.MinimumActiveStakePercentile) {
		return false
	}
	if !this.MaximumActiveStakePercentile.Equal(that1.MaximumActiveStakePercentile) {
		return false
	}
	return true
}
func (this *ActionTransfer) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*ActionTransfer)
	if !ok {
		that2, ok := that.(ActionTransfer)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.MinimumActions != that1.MinimumActions {
		return false
	}
	if this.MaximumActions != that1.MaximumActions {
		return false
	}
	if !this.MinimumDelegationAmount.Equal(&that1.MinimumDelegationAmount) {
		return false
	}
	return true
}
func (this *ActionVote) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*ActionVote)
	if !ok {
		that2, ok := that.(ActionVote)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.MinimumActions != that1.MinimumActions {
		return false
	}
	if this.MaximumActions != that1.MaximumActions {
		return false
	}
	if !this.MinimumDelegationAmount.Equal(&that1.MinimumDelegationAmount) {
		return false
	}
	if this.ValidatorMultiplier != that1.ValidatorMultiplier {
		return false
	}
	return true
}
func (this *ActionCounter) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*ActionCounter)
	if !ok {
		that2, ok := that.(ActionCounter)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.ActionType != that1.ActionType {
		return false
	}
	if this.NumberOfActions != that1.NumberOfActions {
		return false
	}
	return true
}
func (m *RewardProgram) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *RewardProgram) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *RewardProgram) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.QualifyingActions) > 0 {
		for iNdEx := len(m.QualifyingActions) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.QualifyingActions[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintReward(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x1
			i--
			dAtA[i] = 0xaa
		}
	}
	if m.ExpirationOffset != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.ExpirationOffset))
		i--
		dAtA[i] = 0x1
		i--
		dAtA[i] = 0xa0
	}
	if m.State != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.State))
		i--
		dAtA[i] = 0x1
		i--
		dAtA[i] = 0x98
	}
	if m.MaxRolloverClaimPeriods != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.MaxRolloverClaimPeriods))
		i--
		dAtA[i] = 0x1
		i--
		dAtA[i] = 0x90
	}
	if m.CurrentClaimPeriod != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.CurrentClaimPeriod))
		i--
		dAtA[i] = 0x1
		i--
		dAtA[i] = 0x88
	}
	if m.ClaimPeriods != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.ClaimPeriods))
		i--
		dAtA[i] = 0x1
		i--
		dAtA[i] = 0x80
	}
	n1, err1 := github_com_gogo_protobuf_types.StdTimeMarshalTo(m.ActualProgramEndTime, dAtA[i-github_com_gogo_protobuf_types.SizeOfStdTime(m.ActualProgramEndTime):])
	if err1 != nil {
		return 0, err1
	}
	i -= n1
	i = encodeVarintReward(dAtA, i, uint64(n1))
	i--
	dAtA[i] = 0x7a
	n2, err2 := github_com_gogo_protobuf_types.StdTimeMarshalTo(m.ClaimPeriodEndTime, dAtA[i-github_com_gogo_protobuf_types.SizeOfStdTime(m.ClaimPeriodEndTime):])
	if err2 != nil {
		return 0, err2
	}
	i -= n2
	i = encodeVarintReward(dAtA, i, uint64(n2))
	i--
	dAtA[i] = 0x72
	n3, err3 := github_com_gogo_protobuf_types.StdTimeMarshalTo(m.ProgramEndTimeMax, dAtA[i-github_com_gogo_protobuf_types.SizeOfStdTime(m.ProgramEndTimeMax):])
	if err3 != nil {
		return 0, err3
	}
	i -= n3
	i = encodeVarintReward(dAtA, i, uint64(n3))
	i--
	dAtA[i] = 0x6a
	n4, err4 := github_com_gogo_protobuf_types.StdTimeMarshalTo(m.ExpectedProgramEndTime, dAtA[i-github_com_gogo_protobuf_types.SizeOfStdTime(m.ExpectedProgramEndTime):])
	if err4 != nil {
		return 0, err4
	}
	i -= n4
	i = encodeVarintReward(dAtA, i, uint64(n4))
	i--
	dAtA[i] = 0x62
	n5, err5 := github_com_gogo_protobuf_types.StdTimeMarshalTo(m.ProgramStartTime, dAtA[i-github_com_gogo_protobuf_types.SizeOfStdTime(m.ProgramStartTime):])
	if err5 != nil {
		return 0, err5
	}
	i -= n5
	i = encodeVarintReward(dAtA, i, uint64(n5))
	i--
	dAtA[i] = 0x5a
	if m.ClaimPeriodSeconds != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.ClaimPeriodSeconds))
		i--
		dAtA[i] = 0x50
	}
	{
		size, err := m.MinimumRolloverAmount.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x4a
	{
		size, err := m.MaxRewardByAddress.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x42
	{
		size, err := m.ClaimedAmount.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x3a
	{
		size, err := m.RemainingPoolBalance.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x32
	{
		size, err := m.TotalRewardPool.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x2a
	if len(m.DistributeFromAddress) > 0 {
		i -= len(m.DistributeFromAddress)
		copy(dAtA[i:], m.DistributeFromAddress)
		i = encodeVarintReward(dAtA, i, uint64(len(m.DistributeFromAddress)))
		i--
		dAtA[i] = 0x22
	}
	if len(m.Description) > 0 {
		i -= len(m.Description)
		copy(dAtA[i:], m.Description)
		i = encodeVarintReward(dAtA, i, uint64(len(m.Description)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Title) > 0 {
		i -= len(m.Title)
		copy(dAtA[i:], m.Title)
		i = encodeVarintReward(dAtA, i, uint64(len(m.Title)))
		i--
		dAtA[i] = 0x12
	}
	if m.Id != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.Id))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *ClaimPeriodRewardDistribution) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ClaimPeriodRewardDistribution) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ClaimPeriodRewardDistribution) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.ClaimPeriodEnded {
		i--
		if m.ClaimPeriodEnded {
			dAtA[i] = 1
		} else {
			dAtA[i] = 0
		}
		i--
		dAtA[i] = 0x30
	}
	if m.TotalShares != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.TotalShares))
		i--
		dAtA[i] = 0x28
	}
	{
		size, err := m.RewardsPool.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x22
	{
		size, err := m.TotalRewardsPoolForClaimPeriod.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x1a
	if m.RewardProgramId != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.RewardProgramId))
		i--
		dAtA[i] = 0x10
	}
	if m.ClaimPeriodId != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.ClaimPeriodId))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *RewardAccountState) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *RewardAccountState) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *RewardAccountState) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.ClaimStatus != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.ClaimStatus))
		i--
		dAtA[i] = 0x30
	}
	if m.SharesEarned != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.SharesEarned))
		i--
		dAtA[i] = 0x28
	}
	if len(m.ActionCounter) > 0 {
		for iNdEx := len(m.ActionCounter) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.ActionCounter[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintReward(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x22
		}
	}
	if len(m.Address) > 0 {
		i -= len(m.Address)
		copy(dAtA[i:], m.Address)
		i = encodeVarintReward(dAtA, i, uint64(len(m.Address)))
		i--
		dAtA[i] = 0x1a
	}
	if m.ClaimPeriodId != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.ClaimPeriodId))
		i--
		dAtA[i] = 0x10
	}
	if m.RewardProgramId != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.RewardProgramId))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *QualifyingAction) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *QualifyingAction) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *QualifyingAction) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.Type != nil {
		{
			size := m.Type.Size()
			i -= size
			if _, err := m.Type.MarshalTo(dAtA[i:]); err != nil {
				return 0, err
			}
		}
	}
	return len(dAtA) - i, nil
}

func (m *QualifyingAction_Delegate) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *QualifyingAction_Delegate) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	if m.Delegate != nil {
		{
			size, err := m.Delegate.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReward(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}
func (m *QualifyingAction_Transfer) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *QualifyingAction_Transfer) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	if m.Transfer != nil {
		{
			size, err := m.Transfer.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReward(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x12
	}
	return len(dAtA) - i, nil
}
func (m *QualifyingAction_Vote) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *QualifyingAction_Vote) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	if m.Vote != nil {
		{
			size, err := m.Vote.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReward(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x1a
	}
	return len(dAtA) - i, nil
}
func (m *QualifyingActions) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *QualifyingActions) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *QualifyingActions) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.QualifyingActions) > 0 {
		for iNdEx := len(m.QualifyingActions) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.QualifyingActions[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintReward(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0xa
		}
	}
	return len(dAtA) - i, nil
}

func (m *ActionDelegate) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ActionDelegate) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ActionDelegate) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	{
		size := m.MaximumActiveStakePercentile.Size()
		i -= size
		if _, err := m.MaximumActiveStakePercentile.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x32
	{
		size := m.MinimumActiveStakePercentile.Size()
		i -= size
		if _, err := m.MinimumActiveStakePercentile.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x2a
	if m.MaximumDelegationAmount != nil {
		{
			size, err := m.MaximumDelegationAmount.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReward(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x22
	}
	if m.MinimumDelegationAmount != nil {
		{
			size, err := m.MinimumDelegationAmount.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintReward(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x1a
	}
	if m.MaximumActions != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.MaximumActions))
		i--
		dAtA[i] = 0x10
	}
	if m.MinimumActions != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.MinimumActions))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *ActionTransfer) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ActionTransfer) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ActionTransfer) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	{
		size, err := m.MinimumDelegationAmount.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x1a
	if m.MaximumActions != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.MaximumActions))
		i--
		dAtA[i] = 0x10
	}
	if m.MinimumActions != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.MinimumActions))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *ActionVote) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ActionVote) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ActionVote) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.ValidatorMultiplier != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.ValidatorMultiplier))
		i--
		dAtA[i] = 0x20
	}
	{
		size, err := m.MinimumDelegationAmount.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintReward(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x1a
	if m.MaximumActions != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.MaximumActions))
		i--
		dAtA[i] = 0x10
	}
	if m.MinimumActions != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.MinimumActions))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *ActionCounter) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ActionCounter) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ActionCounter) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.NumberOfActions != 0 {
		i = encodeVarintReward(dAtA, i, uint64(m.NumberOfActions))
		i--
		dAtA[i] = 0x10
	}
	if len(m.ActionType) > 0 {
		i -= len(m.ActionType)
		copy(dAtA[i:], m.ActionType)
		i = encodeVarintReward(dAtA, i, uint64(len(m.ActionType)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func encodeVarintReward(dAtA []byte, offset int, v uint64) int {
	offset -= sovReward(v)
	base := offset
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return base
}
func (m *RewardProgram) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.Id != 0 {
		n += 1 + sovReward(uint64(m.Id))
	}
	l = len(m.Title)
	if l > 0 {
		n += 1 + l + sovReward(uint64(l))
	}
	l = len(m.Description)
	if l > 0 {
		n += 1 + l + sovReward(uint64(l))
	}
	l = len(m.DistributeFromAddress)
	if l > 0 {
		n += 1 + l + sovReward(uint64(l))
	}
	l = m.TotalRewardPool.Size()
	n += 1 + l + sovReward(uint64(l))
	l = m.RemainingPoolBalance.Size()
	n += 1 + l + sovReward(uint64(l))
	l = m.ClaimedAmount.Size()
	n += 1 + l + sovReward(uint64(l))
	l = m.MaxRewardByAddress.Size()
	n += 1 + l + sovReward(uint64(l))
	l = m.MinimumRolloverAmount.Size()
	n += 1 + l + sovReward(uint64(l))
	if m.ClaimPeriodSeconds != 0 {
		n += 1 + sovReward(uint64(m.ClaimPeriodSeconds))
	}
	l = github_com_gogo_protobuf_types.SizeOfStdTime(m.ProgramStartTime)
	n += 1 + l + sovReward(uint64(l))
	l = github_com_gogo_protobuf_types.SizeOfStdTime(m.ExpectedProgramEndTime)
	n += 1 + l + sovReward(uint64(l))
	l = github_com_gogo_protobuf_types.SizeOfStdTime(m.ProgramEndTimeMax)
	n += 1 + l + sovReward(uint64(l))
	l = github_com_gogo_protobuf_types.SizeOfStdTime(m.ClaimPeriodEndTime)
	n += 1 + l + sovReward(uint64(l))
	l = github_com_gogo_protobuf_types.SizeOfStdTime(m.ActualProgramEndTime)
	n += 1 + l + sovReward(uint64(l))
	if m.ClaimPeriods != 0 {
		n += 2 + sovReward(uint64(m.ClaimPeriods))
	}
	if m.CurrentClaimPeriod != 0 {
		n += 2 + sovReward(uint64(m.CurrentClaimPeriod))
	}
	if m.MaxRolloverClaimPeriods != 0 {
		n += 2 + sovReward(uint64(m.MaxRolloverClaimPeriods))
	}
	if m.State != 0 {
		n += 2 + sovReward(uint64(m.State))
	}
	if m.ExpirationOffset != 0 {
		n += 2 + sovReward(uint64(m.ExpirationOffset))
	}
	if len(m.QualifyingActions) > 0 {
		for _, e := range m.QualifyingActions {
			l = e.Size()
			n += 2 + l + sovReward(uint64(l))
		}
	}
	return n
}

func (m *ClaimPeriodRewardDistribution) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.ClaimPeriodId != 0 {
		n += 1 + sovReward(uint64(m.ClaimPeriodId))
	}
	if m.RewardProgramId != 0 {
		n += 1 + sovReward(uint64(m.RewardProgramId))
	}
	l = m.TotalRewardsPoolForClaimPeriod.Size()
	n += 1 + l + sovReward(uint64(l))
	l = m.RewardsPool.Size()
	n += 1 + l + sovReward(uint64(l))
	if m.TotalShares != 0 {
		n += 1 + sovReward(uint64(m.TotalShares))
	}
	if m.ClaimPeriodEnded {
		n += 2
	}
	return n
}

func (m *RewardAccountState) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.RewardProgramId != 0 {
		n += 1 + sovReward(uint64(m.RewardProgramId))
	}
	if m.ClaimPeriodId != 0 {
		n += 1 + sovReward(uint64(m.ClaimPeriodId))
	}
	l = len(m.Address)
	if l > 0 {
		n += 1 + l + sovReward(uint64(l))
	}
	if len(m.ActionCounter) > 0 {
		for _, e := range m.ActionCounter {
			l = e.Size()
			n += 1 + l + sovReward(uint64(l))
		}
	}
	if m.SharesEarned != 0 {
		n += 1 + sovReward(uint64(m.SharesEarned))
	}
	if m.ClaimStatus != 0 {
		n += 1 + sovReward(uint64(m.ClaimStatus))
	}
	return n
}

func (m *QualifyingAction) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.Type != nil {
		n += m.Type.Size()
	}
	return n
}

func (m *QualifyingAction_Delegate) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.Delegate != nil {
		l = m.Delegate.Size()
		n += 1 + l + sovReward(uint64(l))
	}
	return n
}
func (m *QualifyingAction_Transfer) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.Transfer != nil {
		l = m.Transfer.Size()
		n += 1 + l + sovReward(uint64(l))
	}
	return n
}
func (m *QualifyingAction_Vote) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.Vote != nil {
		l = m.Vote.Size()
		n += 1 + l + sovReward(uint64(l))
	}
	return n
}
func (m *QualifyingActions) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if len(m.QualifyingActions) > 0 {
		for _, e := range m.QualifyingActions {
			l = e.Size()
			n += 1 + l + sovReward(uint64(l))
		}
	}
	return n
}

func (m *ActionDelegate) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.MinimumActions != 0 {
		n += 1 + sovReward(uint64(m.MinimumActions))
	}
	if m.MaximumActions != 0 {
		n += 1 + sovReward(uint64(m.MaximumActions))
	}
	if m.MinimumDelegationAmount != nil {
		l = m.MinimumDelegationAmount.Size()
		n += 1 + l + sovReward(uint64(l))
	}
	if m.MaximumDelegationAmount != nil {
		l = m.MaximumDelegationAmount.Size()
		n += 1 + l + sovReward(uint64(l))
	}
	l = m.MinimumActiveStakePercentile.Size()
	n += 1 + l + sovReward(uint64(l))
	l = m.MaximumActiveStakePercentile.Size()
	n += 1 + l + sovReward(uint64(l))
	return n
}

func (m *ActionTransfer) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.MinimumActions != 0 {
		n += 1 + sovReward(uint64(m.MinimumActions))
	}
	if m.MaximumActions != 0 {
		n += 1 + sovReward(uint64(m.MaximumActions))
	}
	l = m.MinimumDelegationAmount.Size()
	n += 1 + l + sovReward(uint64(l))
	return n
}

func (m *ActionVote) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.MinimumActions != 0 {
		n += 1 + sovReward(uint64(m.MinimumActions))
	}
	if m.MaximumActions != 0 {
		n += 1 + sovReward(uint64(m.MaximumActions))
	}
	l = m.MinimumDelegationAmount.Size()
	n += 1 + l + sovReward(uint64(l))
	if m.ValidatorMultiplier != 0 {
		n += 1 + sovReward(uint64(m.ValidatorMultiplier))
	}
	return n
}

func (m *ActionCounter) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.ActionType)
	if l > 0 {
		n += 1 + l + sovReward(uint64(l))
	}
	if m.NumberOfActions != 0 {
		n += 1 + sovReward(uint64(m.NumberOfActions))
	}
	return n
}

func sovReward(x uint64) (n int) {
	return (math_bits.Len64(x|1) + 6) / 7
}
func sozReward(x uint64) (n int) {
	return sovReward(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (m *RewardProgram) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReward
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: RewardProgram: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: RewardProgram: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Id", wireType)
			}
			m.Id = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Id |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Title", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Title = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Description", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Description = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DistributeFromAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DistributeFromAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field TotalRewardPool", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.TotalRewardPool.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field RemainingPoolBalance", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.RemainingPoolBalance.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 7:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ClaimedAmount", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.ClaimedAmount.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 8:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaxRewardByAddress", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MaxRewardByAddress.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 9:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinimumRolloverAmount", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MinimumRolloverAmount.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 10:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ClaimPeriodSeconds", wireType)
			}
			m.ClaimPeriodSeconds = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ClaimPeriodSeconds |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 11:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ProgramStartTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_gogo_protobuf_types.StdTimeUnmarshal(&m.ProgramStartTime, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 12:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ExpectedProgramEndTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_gogo_protobuf_types.StdTimeUnmarshal(&m.ExpectedProgramEndTime, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 13:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ProgramEndTimeMax", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_gogo_protobuf_types.StdTimeUnmarshal(&m.ProgramEndTimeMax, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 14:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ClaimPeriodEndTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_gogo_protobuf_types.StdTimeUnmarshal(&m.ClaimPeriodEndTime, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 15:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ActualProgramEndTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_gogo_protobuf_types.StdTimeUnmarshal(&m.ActualProgramEndTime, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 16:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ClaimPeriods", wireType)
			}
			m.ClaimPeriods = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ClaimPeriods |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 17:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field CurrentClaimPeriod", wireType)
			}
			m.CurrentClaimPeriod = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.CurrentClaimPeriod |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 18:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaxRolloverClaimPeriods", wireType)
			}
			m.MaxRolloverClaimPeriods = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MaxRolloverClaimPeriods |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 19:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field State", wireType)
			}
			m.State = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.State |= RewardProgram_State(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 20:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ExpirationOffset", wireType)
			}
			m.ExpirationOffset = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ExpirationOffset |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 21:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field QualifyingActions", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.QualifyingActions = append(m.QualifyingActions, QualifyingAction{})
			if err := m.QualifyingActions[len(m.QualifyingActions)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReward(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthReward
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ClaimPeriodRewardDistribution) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReward
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ClaimPeriodRewardDistribution: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ClaimPeriodRewardDistribution: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ClaimPeriodId", wireType)
			}
			m.ClaimPeriodId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ClaimPeriodId |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field RewardProgramId", wireType)
			}
			m.RewardProgramId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.RewardProgramId |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field TotalRewardsPoolForClaimPeriod", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.TotalRewardsPoolForClaimPeriod.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field RewardsPool", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.RewardsPool.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 5:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field TotalShares", wireType)
			}
			m.TotalShares = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.TotalShares |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 6:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ClaimPeriodEnded", wireType)
			}
			var v int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				v |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			m.ClaimPeriodEnded = bool(v != 0)
		default:
			iNdEx = preIndex
			skippy, err := skipReward(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthReward
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *RewardAccountState) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReward
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: RewardAccountState: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: RewardAccountState: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field RewardProgramId", wireType)
			}
			m.RewardProgramId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.RewardProgramId |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ClaimPeriodId", wireType)
			}
			m.ClaimPeriodId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ClaimPeriodId |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Address", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Address = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ActionCounter", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ActionCounter = append(m.ActionCounter, &ActionCounter{})
			if err := m.ActionCounter[len(m.ActionCounter)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 5:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field SharesEarned", wireType)
			}
			m.SharesEarned = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.SharesEarned |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 6:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ClaimStatus", wireType)
			}
			m.ClaimStatus = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ClaimStatus |= RewardAccountState_ClaimStatus(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipReward(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthReward
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *QualifyingAction) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReward
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: QualifyingAction: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: QualifyingAction: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Delegate", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			v := &ActionDelegate{}
			if err := v.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			m.Type = &QualifyingAction_Delegate{v}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Transfer", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			v := &ActionTransfer{}
			if err := v.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			m.Type = &QualifyingAction_Transfer{v}
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Vote", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			v := &ActionVote{}
			if err := v.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			m.Type = &QualifyingAction_Vote{v}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReward(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthReward
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *QualifyingActions) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReward
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: QualifyingActions: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: QualifyingActions: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field QualifyingActions", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.QualifyingActions = append(m.QualifyingActions, QualifyingAction{})
			if err := m.QualifyingActions[len(m.QualifyingActions)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReward(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthReward
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ActionDelegate) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReward
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ActionDelegate: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ActionDelegate: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinimumActions", wireType)
			}
			m.MinimumActions = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MinimumActions |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaximumActions", wireType)
			}
			m.MaximumActions = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MaximumActions |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinimumDelegationAmount", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.MinimumDelegationAmount == nil {
				m.MinimumDelegationAmount = &types.Coin{}
			}
			if err := m.MinimumDelegationAmount.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaximumDelegationAmount", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.MaximumDelegationAmount == nil {
				m.MaximumDelegationAmount = &types.Coin{}
			}
			if err := m.MaximumDelegationAmount.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinimumActiveStakePercentile", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MinimumActiveStakePercentile.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaximumActiveStakePercentile", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MaximumActiveStakePercentile.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReward(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthReward
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ActionTransfer) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReward
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ActionTransfer: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ActionTransfer: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinimumActions", wireType)
			}
			m.MinimumActions = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MinimumActions |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaximumActions", wireType)
			}
			m.MaximumActions = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MaximumActions |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinimumDelegationAmount", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MinimumDelegationAmount.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipReward(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthReward
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ActionVote) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReward
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ActionVote: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ActionVote: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinimumActions", wireType)
			}
			m.MinimumActions = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MinimumActions |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaximumActions", wireType)
			}
			m.MaximumActions = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MaximumActions |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinimumDelegationAmount", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MinimumDelegationAmount.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field ValidatorMultiplier", wireType)
			}
			m.ValidatorMultiplier = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.ValidatorMultiplier |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipReward(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthReward
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ActionCounter) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowReward
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ActionCounter: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ActionCounter: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ActionType", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthReward
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthReward
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ActionType = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field NumberOfActions", wireType)
			}
			m.NumberOfActions = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowReward
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.NumberOfActions |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipReward(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthReward
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipReward(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	depth := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowReward
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowReward
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
		case 1:
			iNdEx += 8
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowReward
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if length < 0 {
				return 0, ErrInvalidLengthReward
			}
			iNdEx += length
		case 3:
			depth++
		case 4:
			if depth == 0 {
				return 0, ErrUnexpectedEndOfGroupReward
			}
			depth--
		case 5:
			iNdEx += 4
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
		if iNdEx < 0 {
			return 0, ErrInvalidLengthReward
		}
		if depth == 0 {
			return iNdEx, nil
		}
	}
	return 0, io.ErrUnexpectedEOF
}

var (
	ErrInvalidLengthReward        = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowReward          = fmt.Errorf("proto: integer overflow")
	ErrUnexpectedEndOfGroupReward = fmt.Errorf("proto: unexpected end of group")
)
